unit uSelfTest;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Controls,
  Forms,
  StdCtrls,
  ExtCtrls,
  z_prof;

const
  cL = 1;
  cH = 6;

type
  TButtonArr = array [cL..cH] of TButton;

  TForm1 = class(TForm)
    Btn1: TButton;
    Btn2: TButton;
    Btn3: TButton;
    Btn4: TButton;
    Btn5: TButton;
    Btn6: TButton;
    Bevel2: TBevel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Btn1Click(Sender: TObject);
  private
    FProfiler: TZprofiler;
    FButtons : TButtonArr;
    procedure RunCodeBlockLoop(const aCodeBlock, aCount: integer);
  public
    property Profiler: TZProfiler read FProfiler;
    property Buttons : TButtonArr read FButtons;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  ComObj;

const
  cTimesArr: array [cL..cH] of integer = (1, 10, 100, 1000, 10000, 100000);

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
begin
  FProfiler := TZprofiler.Create(Self);
  // buttons array
  FButtons[1] := Btn1;
  FButtons[2] := Btn2;
  FButtons[3] := Btn3;
  FButtons[4] := Btn4;
  FButtons[5] := Btn5;
  FButtons[6] := Btn6;
  // buttons captions
  for i := cL to cH do
    Self.Buttons[i].Caption := Format('%d - [%d]', [cTimesArr[i], i]);
end;

procedure TForm1.RunCodeBlockLoop(const aCodeBlock, aCount: integer);
var
  i: integer;
begin
  for i := 1 to aCount do
  begin
    Self.Profiler.Mark(aCodeBlock, True );
    Self.Profiler.Mark(aCodeBlock, False);
  end;
end;

procedure TForm1.Btn1Click(Sender: TObject);
var
  vCodeBlock: integer;
begin
  vCodeBlock := (Sender as TButton).Tag;
  Self.RunCodeBlockLoop(vCodeBlock, cTimesArr[vCodeBlock]);
end;

end.
